// JavaScript Document
var storedActivityID_main;
var isOver = false;
var loc_attemptCount=0;
var loc_noOfTries=0;
function init_DDM() {
    var storedActivityID;
	$('select.dropdown').attr('aria-setsize', $('select.dropdown').length);
    $('select.dropdown').each(function(index, element) {
        var dropDownID = $(this).attr('id');
        // ** The 'name' attribute for the 'select' tags are not compulsory but is a provision for grouping the combo boxes for together in future. This will enable drop-down's to share a common set of answer / answers among themselves
        var dropDownName = $(this).attr('name');
        var activityID = getActivityID(dropDownID);
        // ** Assigning styles to the options in the drop-downs
        // console.log(activityID);
        var bgStyle = globalScope[activityID + '_bgStyle'].toLowerCase();
        if (bgStyle == 'alternate') {
            var altValue = '1';
            $(this).children().each(function(index, element) {
                $(this).addClass('dd-opt-altcolor-' + altValue);
                altValue = (altValue == '1') ? '2' : '1';
            });
            $(this).addClass('dd-opt-altcolor-1');
        } else {
            $(this).children().each(function(index, element) {
                $(this).addClass('dd-opt-singlecolor');
            });
            $(this).addClass('dd-opt-singlecolor');
        }
		var $dropdownLabel = $(this).parent().parent().find('label[for="'+$(this).attr("id")+'"]');
		$(this).attr('tabindex', (index + 1)).attr('aria-posinset', (index + 1)).attr('aria-labelledby', $dropdownLabel.attr('id')).attr('role', 'combobox');
        $dropdownLabel.attr("aria-hidden", "true");

        // ** Store the Default text of the input fields in a global variable
        /*if($(this).val() != ''){
        globalScope[typeinID + '_value'] = $(this).val();
        // ** Add focus in & out listeners only when there is a default value
        $(this).on('focusin', {activityID:activityID, typeinID:typeinID}, textInput_mouseEventHandler);
        $(this).on('focusout', {activityID:activityID, typeinID:typeinID}, textInput_mouseEventHandler);
        }*/



        // ** Add Event listeners
        $(this).on('change', {
            activityID : activityID,
            dropDownID : dropDownID
        }, dropdown_selectHandler_DDM);

        // ** Disabling the submit button for each activity
        var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
        if (activityID != storedActivityID) {
            storedActivityID = activityID;
            storedActivityID_main = activityID;
            // $('#' + activityID).find(':submit').on('click', {
            jqSubmitBtn.on('click', {
                activityID : activityID
            }, onSubmit_DDM);
            //sortGroups(activityID);
        }
        $(this).attr('tabindex', (index + 1));
        jqSubmitBtn.attr('tabindex', (index + 2));
    });
}

function dropdown_selectHandler_DDM(event) {
    var eventTarget = event.target;
    var eventType = event.type;
    var activityID = event.data.activityID;
    var dropDownID = event.data.dropDownID;
    var jqDropDown = $('#' + dropDownID);
    var text = jqDropDown.val();
    var defaultText = globalScope[dropDownID + '_value'];

    //console.log('eventType = '+eventType+' :: "'+text+'" :: "'+globalScope[dropDownID + '_value']+'"');
    switch(eventType) {
        case "change" :
            updateSubmitButtonState_DDM(dropDownID);
            break;
    }
}

function updateSubmitButtonState_DDM(dropDownID) {
    var activityID = getActivityID(dropDownID);
    var userAnswers = [];
    var totalDD_count = 0;
    $('#' + activityID).find('.dropdown').each(function(index, element) {
        var firstOptionValue = $(this).children(0).val().toLowerCase();
        var selectedOptionValue = $(this).val().toLowerCase();
        //console.log("Current Value = "+selectedOptionValue+" : First Value = "+firstOptionValue);
        if (selectedOptionValue != '' && selectedOptionValue != firstOptionValue) {
            userAnswers.push($(this).val());
        }
        totalDD_count++;
    });

    //console.log("updateSubmitButtonState_DDM() | User Answers = "+userAnswers+" : Length = "+userAnswers.length+" : Total DD count = "+totalDD_count);
    var jqSubmitBtn = $('#' + activityID + '_submit');
    if (jqSubmitBtn.attr('id') != undefined) {
        if (userAnswers.length == totalDD_count) {// ** Enable Submit button
            /*jqSubmitBtn.removeClass('button-images-submit-disabled');
             jqSubmitBtn.addClass('button-images-submit button');
             jqSubmitBtn.removeAttr('disabled');*/
            jqSubmitBtn.removeClass('simple-btn-disabled').addClass('simple-btn');
        } else {// ** Disable Submit button
            /*jqSubmitBtn.removeClass('button-images-submit button');
             jqSubmitBtn.addClass('button-images-submit-disabled');
             jqSubmitBtn.attr('disabled', 'disabled');*/
            jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
        }
    } else {
        alert('ERROR: Submit button with a matching Group / Activity ID not found. The ID needs to be: GroupID + "_submit".');
    };
}

function onSubmit_DDM(event) {
    var eventTarget = event.target;
    if ($(eventTarget).hasClass('simple-btn-disabled')) {
        return;
    }
    //alert('onSubmit_DDM() | '+event.data.activityID);
    var activityID = event.data.activityID;

    // ** Increment the attempt count
    if (globalScope[activityID + '_attemptCount'] == undefined) {
        globalScope[activityID + '_attemptCount'] = 0;
    }
    globalScope[activityID + '_attemptCount'] += 1;

    // ** Get the User Answers
    var userAnswers = [];
    $('#' + activityID).find('.dropdown').each(function() {
        userAnswers.push({
            id : $(this).attr('id'),
            value : $(this).val(),
            index : $(this)[0].selectedIndex
        });
    });

    // ** Get individual Activities validation data
    var correctAnswers = globalScope[activityID + '_correctAnswers'];
    var attemptCount = globalScope[activityID + '_attemptCount'];
    loc_attemptCount = globalScope[activityID + '_attemptCount'];
    var noOfTries = globalScope[activityID + '_noOfTries'];
    loc_noOfTries = globalScope[activityID + '_noOfTries'];
    var showTickCross = globalScope[activityID + '_showTickCross'];
    var feedbackType = globalScope[activityID + '_feedbackType'].toLowerCase();
	// ** Evaluate the User Answers
    var oEvulate = evaluate_DDM(activityID, userAnswers, correctAnswers, showTickCross);
    //console.log('User Correct Count = '+oEvulate.userCorrectCount+' : User Incorrect Count = '+oEvulate.userIncorrectCount);

    var feedbackID;
    var correct = false;

    if (oEvulate.fbType == 'correct') {
        // ** All Correct
        //console.log('Correct');
        correct = true;
        feedbackID = getFeedbackID_DDM('correct', activityID);
    } else {
        // ** Incorrect
        if (oEvulate.userCorrectCount > 0 && feedbackType == "correctincorrectpartial") {
            // ** Partially Correct Feedback
            //console.log('Partially Correct');
            feedbackID = getFeedbackID_DDM('partial', activityID);
        } else {
            // ** ALL Incorrect Feedback
            //console.log('Incorrect');
            feedbackID = getFeedbackID_DDM('incorrect', activityID);
        }
    }

    //showFeedback(feedbackID, popupARIA);
    showFeedback(feedbackID, popupARIA, window.document);
    if ( correct || loc_attemptCount == noOfTries) {
        // ** Disable Activity
        isOver = true;
        disableActivity_DDM(activityID);
        if (showTickCross) {
            //$('#' + activityID + '_tickcross').removeClass('hidden');
            try {
               $('.mcqg-indicator[id^="indicator_"]').removeClass("hidden");
               $('.mcqg-indicator[id^="indicator_"]').removeClass("hide");
            } catch(exception) {
            }
        }
    }
}

function evaluate_DDM(activityID, userAnswers, correctAnswers, showTickCross) {
    var userCorrectCount = 0;
    var userIncorrectCount = 0;
    for (var i = 0; i < userAnswers.length; i++) {
        var ddID = userAnswers[i].id;
        var userAnswerVal = userAnswers[i].value;
        var userAnswerIndex = userAnswers[i].index.toString();
        var ddNo = ddID.substring(ddID.lastIndexOf('_') + 1, ddID.length);
        var correctAnswer = correctAnswers['ddm_' + ddNo];
        var correct = isCorrect_DDM(userAnswerIndex, correctAnswer, false);
        //console.log('userAnswers['+i+'] = '+userAnswerVal+' : correctAnswer['+i+'] = '+correctAnswer+' :: DD '+i+' | is Correct = '+correct);
        (correct) ? userCorrectCount++ : userIncorrectCount++;

        // ** Add Tick and Cross if required
        if (showTickCross) {
            addTickOrCross_DDM(activityID, ddNo, correct);
        }
    }
    if (userCorrectCount == userAnswers.length) {
        // ** All Correct
        return {
            fbType : 'correct',
            userCorrectCount : userCorrectCount,
            userIncorrectCount : userIncorrectCount
        };
    }
    if (userIncorrectCount == userAnswers.length) {
        // ** All Incorrect
        return {
            fbType : 'incorrect',
            userCorrectCount : userCorrectCount,
            userIncorrectCount : userIncorrectCount
        };
    }
    // ** Partially Correct
    return {
        fbType : 'partial',
        userCorrectCount : userCorrectCount,
        userIncorrectCount : userIncorrectCount
    };
    ;
}

function addTickOrCross_DDM(activityID, ddNo, correct) {
    var indicatorID = 'indicator_' + ddNo;
    //var jqTickCross = $('#'+activityID+'_tickcross img[id^="'+indicatorID+'"]');
    var jqTickCross = $('span[id^="' + indicatorID + '"]');
    //console.log(indicatorID+' : Ind ID = '+jqTickCross.attr('id')+' : Parent ID = '+jqTickCross.parent().parent().attr('id'));
	
	if(loc_attemptCount==loc_noOfTries){
    if (correct) {
    	jqTickCross.addClass('correct');
    } else {
    	jqTickCross.addClass('incorrect');
    }
	}
}

function isCorrect_DDM(userAnswer, correctAnswer, caseSensitive) {
    var arr = correctAnswer.split('~');
    for (var j = 1; j < arr.length; j++) {
        //console.log('isCorrect_DDM() | '+userAnswer+' :: '+arr[j]);
        if (caseSensitive) {
            if (userAnswer == arr[j]) {
                return true;
            }
        } else {
            if (userAnswer.toLowerCase() == arr[j].toLowerCase()) {
                return true;
            }
        }
    }
    return false;
}

function getFeedbackID_DDM(evaluation, activityID) {
    //console.log('getFeedbackID_DDM() | evaluation = '+evaluation+' : Activity ID = '+activityID);
    var feedbackID;
    var feedbackType = globalScope[activityID + '_feedbackType'].toLowerCase();
    var attemptCount = globalScope[activityID + '_attemptCount'];

    if (feedbackType == 'generic') {
        feedbackID = activityID + '_generic';
    } else if (feedbackType == 'correctincorrect' || feedbackType == 'correctincorrectpartial') {
        feedbackID = activityID + '_' + evaluation + '_' + attemptCount;
    } else {
        alert('ERROR: Feedback Type specified "' + feedbackType + '" is invalid. Valid feedback types are:\n1) Generic\n2) CorrectIncorrect\n3) CorrectIncorrectPartial');
    }

    return feedbackID;
}

function disableActivity_DDM(activityID) {
    //console.log('disableActivity_DDM() | Activity ID = '+activityID);
    var storedActivityID;
    $('#' + activityID).find('.dropdown').each(function(index, element) {
        $(this).removeClass('dd-color dd-opt-singlecolor dd-opt-altcolor-1 dd-opt-altcolor-2').addClass('isOver');
        $(this).children().each(function(index, element) {
            $(this).removeClass('dd-opt-singlecolor dd-opt-altcolor-1 dd-opt-altcolor-2');
            $(this).addClass('dropdown-disabled');
        });
        $(this).addClass('dropdown-disabled');
        $(this).attr('disabled', 'disabled');
    });
    // var jqSubmitBtn = $('#' + activityID).find(':submit');
    var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
    /*jqSubmitBtn.removeClass('button-images-submit button');
     jqSubmitBtn.addClass('button-images-submit-disabled');
     jqSubmitBtn.attr('disabled', 'disabled');*/
    jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
}

function onClosePopup() {
    if (!isOver) {
        var activityID = storedActivityID_main;
        $('#' + activityID).find('.dropdown').each(function(index, element) {
            $(this)[0].selectedIndex = 0;
        });
        var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
        jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
    }
}