// JavaScript Document
var oActivityMasterData = {}, iSubmitButtonIdx = 2;

var storedActivityID_main;
var isMCQG = false;

var init_MCQ = function(oMCQ) {
	var activityID = oMCQ['activityID'], jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]'), iCount = 0;

	oActivityMasterData[activityID] = oMCQ;

	$('#' + activityID).find('.radio').each(function(index, element) {
		var $radioBtn = $(this), $radioLbl = $radioBtn.parent().find('label.radio-label');

		$radioBtn.attr('checked', null).attr('tabindex', (index + 1)).attr('aria-posinset', (index + 1)).attr('aria-label', $radioLbl.text());
		$radioLbl.attr('aria-hidden', true);

		$radioBtn.on("click", {
			'activityID' : activityID,
			'isMCQG' : oMCQ['isMCQG'],
			'radioObj' : $radioBtn
		}, mouseEventHandler_MCQ);
		
		$radioBtn.siblings('.radio-label.button').prepend('<span class="radio_states"></span>');
		
		iCount++;
	});

	iSubmitButtonIdx += iCount

	jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
	jqSubmitBtn.on('click', {
		'activityID' : activityID,
		'isMCQG' : oMCQ['isMCQG']
	}, onSubmit_MCQ);
	jqSubmitBtn.attr('aria-disabled', 'true').attr('tabindex', iSubmitButtonIdx);

	$('input[type="radio"]').attr('aria-setsize', $('input[type="radio"]').length);
	$(':radio').focus(function() {
		$(this).parent().find('label').addClass('focus');
	}).blur(function() {
		$(this).parent().find('label').removeClass('focus');
	});
	
};

var mouseEventHandler_MCQ = function(event) {

	var radioObj = event.data.radioObj, radioLabelObj = $('#' + radioObj.attr('id') + '_lbl'), radioID = radioObj.attr('id'), radioGroupID = radioObj.parent().attr("id"), activityID = event.data.activityID, isMCQG = event.data.isMCQG, groupID = radioObj.attr('name');

	//console.log('groupID: ' + groupID + ' radioID: ' + radioID);
	//console.log('    SEL: ' + globalScope[groupID + "_selected"]);

	// ** Updating the skin of previously selected Radio button
	if (globalScope[groupID + "_selected"] != undefined) {
		// var skinURL = '0px 0px';
		// $('#' + globalScope[groupID + "_selected"] + '_lbl').css('background-position', skinURL);
		$('#' + globalScope[groupID + "_selected"] + '_lbl').removeClass('radio-label-checked');
		$('#' + globalScope[groupID + "_selected"] + '_lbl').find('.radio_states').removeClass('checked');
	}

	// ** Storing the selected Radio Button Label
	globalScope[groupID + "_selected"] = radioID;

	// ** If the Label ID does not map to the Checkbox Button's ID throw an error
	if (radioLabelObj == null) {
		alert('ERROR: Label ID doesn&apos;t map to the radio button ID. The label ID need to be: radioID + "_lbl".');
		return;
	}

	// ** Updating the Selected Radio Button Skin
	//var imageURL = radioLabelObj.css('backgroundImage');
	//var o = getImageName(imageURL);
	//var skinURL = ($('#'+radioID).is(':checked')) ? 'url(images/radiobtn_over.png)' : 'url(images/radiobtn_up.png)';
	//var skinURL = ($('#'+radioID).is(':checked')) ? 'url('+o.fileName+'_over.'+o.ext+')' : 'url('+o.fileName+'_up.'+o.ext+')';
	//radioLabelObj.css('backgroundImage', skinURL);

	// var skinURL = ($('#' + radioID).is(':checked')) ? '0px -18px' : '0px 0px';
	// radioLabelObj.css('background-position', skinURL);
	var skinClass = ($('#' + radioID).is(':checked')) ? 'radio-label-checked' : 'radio-label-unchecked';
	radioLabelObj.addClass(skinClass);
	skinClass = ($('#' + radioID).is(':checked')) ? 'checked' : 'unchecked';
	radioLabelObj.find('.radio_states').addClass(skinClass);

	updateSubmitButtonState_MCQ(activityID, isMCQG);
}
var updateSubmitButtonState_MCQ = function(activityID, isMCQG) {
	var enableSubmit = true, jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');

	$('.radio:input[id^=' + activityID + ']').each(function(index, element) {
		var radioObj = $(this), groupID = radioObj.attr('name');

		if (globalScope[groupID + "_selected"] == undefined) {
			enableSubmit = false;
		}
	});

	if (jqSubmitBtn.attr('id') != undefined) {
		if (enableSubmit) {
			jqSubmitBtn.attr('aria-disabled', 'false');
			jqSubmitBtn.removeClass('simple-btn-disabled').addClass('simple-btn');
		} else {
			jqSubmitBtn.attr('aria-disabled', 'true');
			jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
		}
	} else {
		alert('ERROR: Submit button with a matching Group / Activity ID not found. The ID needs to be: GroupID + "_submit".');
	}
};

var onSubmit_MCQ = function(event) {
	event.preventDefault();
	var eventTarget = event.target;
	var eventType = event.type;
	//console.log("Event Called | " + eventTarget + " : " + eventType + " : " + eventTarget.id + ' : ' + $(eventTarget).hasClass('simple-btn-disabled'));
	if (!$(eventTarget).hasClass('simple-btn-disabled')) {
		evaluate_MCQ(event);
	}
};

var evaluate_MCQ = function(event) {
	var activityID 		= event.data.activityID, 
		oData 			= oActivityMasterData[activityID], 
		correctAnswers 	= oData['correctAnswers'], 
		noOfTries 		= oData['noOfTries'], 
		attemptCount 	= oData['attemptCount'] + 1, 
		feedbackType 	= oData['feedbackType'].toLowerCase(), 
		popupARIA 		= oData['popupARIA'], 
		showTickCross 	= oData['showTickCross'],
		
		bIsCallback 	= (typeof oData['isCallback'] == 'undefined') ? false : oData['isCallback'],
		
		userAnswers 	= [], 
		correct 		= false, 
		userCorrectCount, 
		feedbackID, 
		buttonId;

	// update the attempt count
	oActivityMasterData[activityID]['attemptCount'] = attemptCount;

	// Get the User Answers
	$('#' + activityID).find('.radio:checked').each(function() {
		//userAnswers.push($(this).val());
		buttonId = $(this).attr('id');
		userAnswers.push(Number(getElementID(buttonId)));
		//console.log("Button value attribute : "+ $(this).val()+" : "+buttonId);
	});

	userCorrectCount = getUserCorrectCount_MCQ(userAnswers, correctAnswers);

	//console.log(correctAnswers.join('')+' == '+userAnswers.join(''));
	if (correctAnswers.join('') == userAnswers.join('')) {
		// All Correct
		correct = true;
		feedbackID = getFeedbackID_MCQ('correct', activityID, buttonId, feedbackType, attemptCount);
	} else {
		// Incorrect
		if (userCorrectCount > 0 && feedbackType == "correctincorrectpartial") {
			// Partially Correct Feedback
			feedbackID = getFeedbackID_MCQ('partial', activityID, buttonId, feedbackType, attemptCount);
		} else {
			// ALL Incorrect Feedback
			feedbackID = getFeedbackID_MCQ('incorrect', activityID, buttonId, feedbackType, attemptCount);
		}
	}

	showFeedback(feedbackID, popupARIA, window.document, activityID);

	if (attemptCount == noOfTries || correct) {
		// Disable Activity
		disableActivity_MCQ(activityID);
		if (feedbackID != "none") {
			if (showTickCross) {
				$('#' + activityID + "_tickcross").removeClass("hidden");
			}
		} else {
			activateNextPage(correct);
		}
		try {
			$('#' + activityID).find('span[id^="indicator_"]').removeClass("hidden");
			$('#' + activityID).find('span[id^="indicator_"]').removeClass("hide");
		} 
		catch(exception) {
			
		}
	}
	
	if(bIsCallback){
		var fCallback = oData['fCallback'];
		if(typeof fCallback == "function" ){
			fCallback();
		}
		
	}
	
};

var getFeedbackID_MCQ = function (evaluation, activityID, buttonId, feedbackType, attemptCount) {
	var feedbackID;
	
	switch(feedbackType){
		case 'generic':
			feedbackID = activityID + "_generic";
			break;
		case 'correctincorrect':
		case 'correctincorrectpartial':
			feedbackID = activityID + "_" + evaluation + "_" + attemptCount;
			break;
		case 'specific':
			feedbackID = buttonId + "_specific";
			break;
		case 'attemptspecific':
			feedbackID = buttonId + "_specific_" + attemptCount;
			break;
		case 'none':
			feedbackID = "none";
			break;
		default:
			alert('ERROR: Feedback Type specified "' + feedbackType + '" is invalid. Valid feedback types are:\n1) Generic\n2) CorrectIncorrect\n3) CorrectIncorrectPartial\n4) Specific\n5) AttempeSpecific');	
	};
	return feedbackID;
};

var getUserCorrectCount_MCQ = function (userAnswers, correctAnswers) {
	userCorrectCount = 0;
	for (var i = 0; i < userAnswers.length; i++) {
		if (userAnswers[i] == correctAnswers[i]) {
			userCorrectCount++;
		}
	}
	return userCorrectCount;
};

var disableActivity_MCQ = function (activityID) {
	$('#' + activityID).find('.radio').each(function(index, element) {
		$(this).removeClass('button').addClass('isOver');
		$(this).attr('disabled', 'disabled');
		
		var jqLabelObj = $('#' + $(this).attr('id') + '_lbl'),
			skinClass = ($(this).is(':checked')) ? 'radio-label-checked-disabled' : 'radio-label-unchecked-disabled';
			
		jqLabelObj.addClass(skinClass);
		skinClass = ($(this).is(':checked')) ? 'checked disabled' : 'unchecked disabled';
		jqLabelObj.find('.radio_states').addClass(skinClass);
		jqLabelObj.removeClass('button');
	});
	
	var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
	jqSubmitBtn.attr('aria-disabled', 'true');
	jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
};

var disableScreen = function(p_bEnable, activityID) {
	var bEnable = (p_bEnable) ? 'true' : 'false';
	//$('.activity-header').attr('aria-hidden', bEnable);
	//$('#leadin-wrap').attr('aria-hidden', bEnable);
	//$('#branch-wrap').attr('aria-hidden', bEnable);
	if (p_bEnable) {
		if(typeof activityID == 'undedfined'){
			var activityID = storedActivityID_main;
		}
		var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
		jqSubmitBtn.focus();
	}
};

var onClosePopup = function(activityID) {
	//console.log('onClosePopup() # '+$('label[id^="' + activityID + '"]').hasClass('button'));
	if(typeof activityID == 'undedfined'){
		var activityID = storedActivityID_main;
	}
	$('label[id^="' + activityID + '"]').removeClass('radio-label-checked').addClass('radio-label');
	if ($('label[id^="' + activityID + '"]').hasClass('button')) {
		$('label[id^="' + activityID + '"]').find('.radio_states').removeClass('checked');
		$("input:radio").removeAttr("checked");
	}
	var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
	jqSubmitBtn.attr('aria-disabled', 'true');
	jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
};

var changeImageSrc_MCQ = function(inputElementID, eventType) {
	var currentImgSrc = $('#' + inputElementID).css('background-image');
	var o = getImageName(currentImgSrc);
	var targetImgSrc = 'url("' + o.fileName + '_' + eventType + '.' + o.ext + '")';
	//console.log('Replace Image with "'+targetImgSrc+'"');
	try {
		$('#' + inputElementID).css('background-image', targetImgSrc);
	} catch(e) {
	}
};

/*function init_MCQ() {
 var storedActivityID;
 $('.radio').each(function(index, element) {
 var activityID = getActivityID($(this).attr('id'));
 if (isMCQG) {
 activityID = activityID.substr(0, activityID.lastIndexOf("_"));
 }
 var $radioBtn = $(this);
 var $radioLbl = $radioBtn.parent().find('label.radio-label');
 $radioBtn.attr('checked', null).attr('tabindex', (index + 1)).attr('aria-posinset', (index + 1)).attr('aria-label', $radioLbl.text());
 $radioLbl.attr('aria-hidden', true);
 $radioBtn.on("click", {
 activityID : activityID,
 radioObj : $radioBtn
 }, mouseEventHandler_MCQ);

 var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
 if (activityID != storedActivityID) {
 //storedActivityID = activityID;
 storedActivityID_main.push(activityID);
 // var jqSubmitBtn = $('#' + activityID).find(':submit');
 // jqSubmitBtn.addClass('button-images-submit-disabled');
 jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
 jqSubmitBtn.on('click', {
 activityID : activityID
 }, onSubmit_MCQ);
 }
 jqSubmitBtn.attr('aria-disabled', 'true').attr('tabindex', (index + 2));
 //console.log((index + 1) + ' : ' + jqSubmitBtn + ' : ' + (index + 2));
 });

 $('input[type="radio"]').attr('aria-setsize', $('input[type="radio"]').length);
 $(':radio').focus(function() {
 $(this).parent().find('label').addClass('focus');
 }).blur(function() {
 $(this).parent().find('label').removeClass('focus');
 });
 $('.radio-label.button').prepend('<span class="radio_states"></span>');
 }

 function init_MCQGroup() {
 isMCQG = true;
 init_MCQ();
 }

 */

/* function mouseEventHandler_MCQ(event) {
 var radioObj = event.data.radioObj;
 var radioLabelObj = $('#' + radioObj.attr('id') + '_lbl');

 var radioID = radioObj.attr('id');
 var radioGroupID = radioObj.parent().attr("id");

 var activityID = getActivityID(radioID);

 var groupID = radioObj.attr('name');
 //console.log('groupID: ' + groupID + ' radioID: ' + radioID);
 //console.log('    SEL: ' + globalScope[groupID + "_selected"]);

 // ** Updating the skin of previously selected Radio button
 if (globalScope[groupID + "_selected"] != undefined) {
 // var skinURL = '0px 0px';
 // $('#' + globalScope[groupID + "_selected"] + '_lbl').css('background-position', skinURL);
 $('#' + globalScope[groupID + "_selected"] + '_lbl').removeClass('radio-label-checked');
 $('#' + globalScope[groupID + "_selected"] + '_lbl').find('.radio_states').removeClass('checked');
 }

 // ** Storing the selected Radio Button Label
 globalScope[groupID + "_selected"] = radioID;

 // ** If the Label ID does not map to the Checkbox Button's ID throw an error
 if (radioLabelObj == null) {
 alert('ERROR: Label ID doesn&apos;t map to the radio button ID. The label ID need to be: radioID + "_lbl".');
 return;
 }

 // ** Updating the Selected Radio Button Skin
 //var imageURL = radioLabelObj.css('backgroundImage');
 //var o = getImageName(imageURL);
 //var skinURL = ($('#'+radioID).is(':checked')) ? 'url(images/radiobtn_over.png)' : 'url(images/radiobtn_up.png)';
 //var skinURL = ($('#'+radioID).is(':checked')) ? 'url('+o.fileName+'_over.'+o.ext+')' : 'url('+o.fileName+'_up.'+o.ext+')';
 //radioLabelObj.css('backgroundImage', skinURL);

 // var skinURL = ($('#' + radioID).is(':checked')) ? '0px -18px' : '0px 0px';
 // radioLabelObj.css('background-position', skinURL);
 var skinClass = ($('#' + radioID).is(':checked')) ? 'radio-label-checked' : 'radio-label-unchecked';
 radioLabelObj.addClass(skinClass);
 skinClass = ($('#' + radioID).is(':checked')) ? 'checked' : 'unchecked';
 radioLabelObj.find('.radio_states').addClass(skinClass);

 updateSubmitButtonState_MCQ(radioID);
 }*/

/*function updateSubmitButtonState_MCQ(objectID) {
 var activityID = getActivityID(objectID);
 if (isMCQG) {
 activityID = activityID.substr(0, activityID.lastIndexOf("_"));
 }
 var enableSubmit = true;

 $('.radio:input[id^=' + activityID + ']').each(function(index, element) {
 var activityID = getActivityID($(this).attr('id'));
 var radioObj = $(this);
 var groupID = radioObj.attr('name');
 //console.log("Radio ID = " + groupID + ' : ' + globalScope[groupID + "_selected"]);
 if (globalScope[groupID + "_selected"] == undefined) {
 enableSubmit = false;
 }
 });
 //console.log("updateSubmitButtonState_MCQ() | "+selectedCheckboxes+" : "+selectedCheckboxes.length);

 // var jqSubmitBtn = $('#' + activityID).find(':submit');
 var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
 //console.log(jqSubmitBtn +' : '+ activityID);
 if (jqSubmitBtn.attr('id') != undefined) {
 if (enableSubmit) {
 // *jqSubmitBtn.removeClass('button-images-submit-disabled');
 // jqSubmitBtn.addClass('button-images-submit button');
 // jqSubmitBtn.removeAttr('disabled');
 jqSubmitBtn.attr('aria-disabled', 'false');
 jqSubmitBtn.removeClass('simple-btn-disabled').addClass('simple-btn');
 } else {
 // *jqSubmitBtn.addClass('button-images-submit-disabled');
 jqSubmitBtn.removeClass('button-images-submit button');
 jqSubmitBtn.attr('disabled', 'disabled');* /
 //console.log("Submit ARIA Disabled # updateSubmitButtonState_MCQ() # = "+jqSubmitBtn.attr('aria-disabled'));
 jqSubmitBtn.attr('aria-disabled', 'true');
 jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
 }
 } else {
 alert('ERROR: Submit button with a matching Group / Activity ID not found. The ID needs to be: GroupID + "_submit".');
 };
 }

 function onSubmit_MCQ(event) {
 event.preventDefault();
 var eventTarget = event.target;
 var eventType = event.type;
 //console.log("Event Called | " + eventTarget + " : " + eventType + " : " + eventTarget.id + ' : ' + $(eventTarget).hasClass('simple-btn-disabled'));
 if (!$(eventTarget).hasClass('simple-btn-disabled')) {
 evaluate_MCQ(event);
 }
 }

 function changeImageSrc_MCQ(inputElementID, eventType) {
 var currentImgSrc = $('#' + inputElementID).css('background-image');
 var o = getImageName(currentImgSrc);
 var targetImgSrc = 'url("' + o.fileName + '_' + eventType + '.' + o.ext + '")';
 //console.log('Replace Image with "'+targetImgSrc+'"');
 try {
 $('#' + inputElementID).css('background-image', targetImgSrc);
 } catch(e) {
 }
 }

 function evaluate_MCQ(event) {
 var activityID = event.data.activityID;
 // ** Increment the attempt count
 if (globalScope[activityID + '_attemptCount'] == undefined) {
 globalScope[activityID + '_attemptCount'] = 0;
 }
 globalScope[activityID + '_attemptCount'] += 1;

 // ** Get the User Answers
 var userAnswers = [];
 var buttonId;

 $('#' + activityID).find('.radio:checked').each(function() {
 //userAnswers.push($(this).val());
 buttonId = $(this).attr('id');
 userAnswers.push(Number(getElementID(buttonId)));
 //console.log("Button value attribute : "+ $(this).val()+" : "+buttonId);
 });

 if (!variableExists(activityID + '_correctAnswers', globalScope)) {
 return;
 };
 var correctAnswers = globalScope[activityID + '_correctAnswers'];

 if (!variableExists(activityID + '_noOfTries', globalScope)) {
 return;
 };
 var noOfTries = globalScope[activityID + '_noOfTries'];

 if (!variableExists(activityID + '_attemptCount', globalScope)) {
 return;
 };
 var attemptCount = globalScope[activityID + '_attemptCount'];

 if (!variableExists(activityID + '_feedbackType', globalScope)) {
 return;
 };
 var feedbackType = globalScope[activityID + '_feedbackType'].toLowerCase();

 //console.log("userAnswers : "+ userAnswers+" \ncorrectAnswers : "+ correctAnswers);

 var userCorrectCount = getUserCorrectCount_MCQ(userAnswers, correctAnswers);

 var feedbackID;
 var correct = false;

 //console.log(correctAnswers.join('')+' == '+userAnswers.join(''));
 if (correctAnswers.join('') == userAnswers.join('')) {
 // ** All Correct
 //console.log('Correct');
 correct = true;
 feedbackID = getFeedbackID_MCQ('correct', activityID, buttonId);
 } else {
 // ** Incorrect
 if (userCorrectCount > 0 && feedbackType == "correctincorrectpartial") {
 // ** Partially Correct Feedback
 //console.log('Partially Correct | userCorrectCount = '+userCorrectCount);
 feedbackID = getFeedbackID_MCQ('partial', activityID, buttonId);
 } else {
 // ** ALL Incorrect Feedback
 //console.log('Incorrect | userCorrectCount = '+userCorrectCount);
 feedbackID = getFeedbackID_MCQ('incorrect', activityID, buttonId);
 }
 }
 //console.log('feedbackID: ' + feedbackID);
 //showFeedback(feedbackID, popupARIA);
 showFeedback(feedbackID, popupARIA, window.document);

 if (attemptCount == noOfTries || correct) {
 // ** Disable Activity
 disableActivity_MCQ(activityID);
 if (feedbackID != "none") {
 if (!variableExists(activityID + '_showTickCross', globalScope)) {
 return;
 };
 if (globalScope[activityID + '_showTickCross']) {
 $('#' + activityID + "_tickcross").removeClass("hidden");
 }
 } else {
 activateNextPage(correct);
 }
 try {
 $('img[id^="indicator_"]').removeClass("hidden");
 $('img[id^="indicator_"]').removeClass("hide");
 } catch(exception) {
 }

 }
 }

function getFeedbackID_MCQ(evaluation, activityID, buttonId) {
	var feedbackID;
	var feedbackType = globalScope[activityID + '_feedbackType'].toLowerCase();
	var attemptCount = globalScope[activityID + '_attemptCount'];
	//console.log("feedbackType " + feedbackType);
	if (feedbackType == "generic") {
		feedbackID = activityID + "_generic";
	} else if (feedbackType == "correctincorrect" || feedbackType == "correctincorrectpartial") {
		feedbackID = activityID + "_" + evaluation + "_" + attemptCount;
	} else if (feedbackType == "specific") {
		feedbackID = buttonId + "_specific";
	} else if (feedbackType == "attemptspecific") {
		feedbackID = buttonId + "_specific_" + attemptCount;
	} else if (feedbackType == "none") {
		feedbackID = "none";
	} else {
		alert('ERROR: Feedback Type specified "' + feedbackType + '" is invalid. Valid feedback types are:\n1) Generic\n2) CorrectIncorrect\n3) CorrectIncorrectPartial\n4) Specific\n5) AttempeSpecific');
	}
	return feedbackID;
}

function getUserCorrectCount_MCQ(userAnswers, correctAnswers) {
	//console.log("getUserCorrectCount_MCQ() | userAnswers = "+userAnswers+"\ncorrectAnswers = "+correctAnswers);
	userCorrectCount = 0;
	for (var i = 0; i < userAnswers.length; i++) {
		//console.log('userAnswers['+i+'] = '+userAnswers[i]+' :: '+correctAnswers.indexOf(userAnswers[i])+' :: correctAnswers = '+correctAnswers);
		if (userAnswers[i] == correctAnswers[i]) {
			userCorrectCount++;
		}
	}

	return userCorrectCount;
}

function disableActivity_MCQ(activityID) {
	var storedActivityID;
	$('#' + activityID).find('.radio').each(function(index, element) {
		$(this).removeClass('button').addClass('isOver');
		$(this).attr('disabled', 'disabled');
		var jqLabelObj = $('#' + $(this).attr('id') + '_lbl');

		// var skinURL = ($(this).is(':checked')) ? '0px -54px' : '0px -36px';
		// jqLabelObj.css('background-position', skinURL);

		var skinClass = ($(this).is(':checked')) ? 'radio-label-checked-disabled' : 'radio-label-unchecked-disabled';
		jqLabelObj.addClass(skinClass);
		skinClass = ($(this).is(':checked')) ? 'checked disabled' : 'unchecked disabled';
		jqLabelObj.find('.radio_states').addClass(skinClass);

		jqLabelObj.removeClass('button');

		var activityID = getActivityID($(this).attr('id'));
		if (isMCQG) {
			activityID = activityID.substr(0, activityID.lastIndexOf("_"));
		}
		if (activityID != storedActivityID) {
			storedActivityID = activityID;
			// var jqSubmitBtn = $('#' + activityID).find(':submit');
			var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
			// *jqSubmitBtn.removeClass('button-images-submit button');
			 jqSubmitBtn.css('background-image', '');
			 jqSubmitBtn.addClass('button-images-submit-disabled');
			 jqSubmitBtn.attr('disabled', 'disabled');* /
			jqSubmitBtn.attr('aria-disabled', 'true');
			jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
		}

	});
}*/

/*
function onClosePopup() {
	//console.log('onClosePopup() # '+$('label[id^="' + activityID + '"]').hasClass('button'));
	var activityID = storedActivityID_main;
	$('label[id^="' + activityID + '"]').removeClass('radio-label-checked').addClass('radio-label');
	if ($('label[id^="' + activityID + '"]').hasClass('button')) {
		$('label[id^="' + activityID + '"]').find('.radio_states').removeClass('checked');
		$("input:radio").removeAttr("checked");
	}
	var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
	jqSubmitBtn.attr('aria-disabled', 'true');
	jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
}

function disableScreen(p_bEnable) {
	var bEnable = (p_bEnable) ? 'true' : 'false';
	$('.activity-header').attr('aria-hidden', bEnable);
	$('#leadin-wrap').attr('aria-hidden', bEnable);
	$('#branch-wrap').attr('aria-hidden', bEnable);
	if (p_bEnable) {
		var activityID = storedActivityID_main;
		var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
		jqSubmitBtn.focus();
	}
}
*/